package xso.jetty.main;

import java.awt.EventQueue;

import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.webapp.WebAppContext;

import webapp.WebAppResources;

public class JettyWebServer
{
  public static void main( String[] args )
  {
    Runnable runner = new Runnable()
    {
      private Server server;

      @Override
      public void run()
      {
        try
        {
          server = new Server( 8080 );

          // define ResourceBase via WebAppResources in a way that it also runs from an exported runnable jar
          Class<?> clazz = WebAppResources.class;
          String path = strip( clazz.getName(), "." + clazz.getSimpleName() ).replace( ".", "/" ); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
          String resourceBase = clazz.getClassLoader().getResource( path ).toExternalForm();
          // Stipt last /
          while ( resourceBase.endsWith( "/" ) ) //$NON-NLS-1$
            resourceBase = resourceBase.substring( 0, resourceBase.length() - 1 );

          WebAppContext webapp = new WebAppContext( resourceBase, "/" );
          server.setHandler( webapp );

          server.start();
        }
        catch ( Exception e )
        {
          e.printStackTrace();
        }
      }
    };
    EventQueue.invokeLater( runner );
  }

  public synchronized static String strip( String value, String suffix )
  {
    if ( value.endsWith( suffix ) )
      value = value.substring( 0, value.length() - suffix.length() );
    return value;
  }
}
